/* begincopyright
  Copyright (c) 1988 Xerox Corporation. All rights reserved.
  Use and copying of this software and preparation of derivative works based
  upon this software are permitted. Any distribution of this software or
  derivative works must comply with all applicable United States export
  control laws. This software is made available AS IS, and Xerox Corporation
  makes no warranty about the software, its performance or its conformity to
  any specification. Any person obtaining a copy of this software is requested
  to send their name and post office or electronic mail address to:
    PCR Coordinator
    Xerox PARC
    3333 Coyote Hill Rd.
    Palo Alto, CA
  endcopyright */
/* xrsh.h */
/* Litman - created             30-Sep-87 14:40:39 */
/* Weiser, December 3, 1988 */
/* Demers, April 10, 1990 8:42:15 am PDT */
/* Hauser, August 14, 1989 4:58:07 pm PDT */

/* program interface for dynamic loading */
/* errors are printed to standard out */

#ifndef _XR_COMMAND_LOOP_
#   include "xr/CommandLoop.h"
#endif

#ifdef UNDEFINED

--> This is obsolete <--

extern void XR_call ();
  /* char *function;	must be in the file last loaded */

/* Loads the file if it has not been loaded already. */
/* This proc is called if you use the "DYNAMIC REQUESTS" construct in C/Mesa */ 
extern void XR_request ();
  /* char *file; */

typedef double (*(*CommandProc))();
	/* char *restOfLine */

typedef int (*Installer_Func)();

/* Registers the command with xrsh. */
extern void XR_register ();
  /* char *key; 	-- name of the command */
  /* CommandProc proc;	-- proc to be called */
  /* char *doc;		-- short blurb about the command */
  /* void *clientData;	-- clientData gets passed to proc */

typedef void (*InstallFunc)();

#define MAX_CMD_LEN 256
#define DBX_WAIT_TIME 5

typedef struct Reg_self {
	char *key;
	CommandProc proc;
	char *doc;
	void *clientData;
	struct Reg_self *next;
	char *command;
	} Reg;

/*
 *   Global data.
 */

extern struct CMDGLOBAL {
int timing_commands;
char *command;
int Dyload_Inited;
struct XR_JmpBufRep global_jump_buf;
int global_check_load;
Reg *registered_cmds;
char *loader_directory;
char *postcmdfile;
char *precmdfile;
short nodotcedarboot;
short NoBasicDotLoadeeCommands;
short NoDBXFile;
short NoDyLoad;
short NoDebugger;
char loader_directory_buf[128];	/* can't use malloc because of debug tool */
} *XR_cmdglobal;

#define CMDGLOBAL_timing_commands (XR_cmdglobal->timing_commands)
#define CMDGLOBAL_command (XR_cmdglobal->command)
#define CMDGLOBAL_Dyload_Inited (XR_cmdglobal->Dyload_Inited)
#define CMDGLOBAL_global_jump_buf (XR_cmdglobal->global_jump_buf)
#define CMDGLOBAL_global_check_load (XR_cmdglobal->global_check_load)
#define CMDGLOBAL_registered_cmds (XR_cmdglobal->registered_cmds)
#define CMDGLOBAL_loader_directory (XR_cmdglobal->loader_directory)
#define CMDGLOBAL_nodotxrboot (XR_cmdglobal->nodotcedarboot)
#define CMDGLOBAL_NoBasicDotLoadeeCommands (XR_cmdglobal->NoBasicDotLoadeeCommands)
#define CMDGLOBAL_NoDBXFile (XR_cmdglobal->NoDBXFile)
#define CMDGLOBAL_NoDyLoad (XR_cmdglobal->NoDyLoad)
#define CMDGLOBAL_postcmdfile (XR_cmdglobal->postcmdfile)
#define CMDGLOBAL_precmdfile (XR_cmdglobal->precmdfile)
#define CMDGLOBAL_NoDebugger (XR_cmdglobal->NoDebugger)
#define CMDGLOBAL_loader_directory_buf (XR_cmdglobal->loader_directory_buf)

#endif /* UNDEFINED */
